
volatile u32 tim[6];
#define MSR_TIM    tim[0]
#define HT_TIM     tim[1]
#define SB_TIM     tim[2]
#define LED_TIM    tim[3]
#define ERR_TIM    tim[4]
#define VDD_TIM    tim[5]

extern "C"
{
 void SysTick_Handler()
 {
  for(int i=0;i<sizeof(tim)/sizeof(tim[0]);i++) if(tim[i])tim[i]--;

  beep_processing();
 }
//-----------------------------------

 void DMA1_Channel4_5_IRQHandler()
 {
  // 
  DMA1_Channel5->CCR = 0;

  TIM1->RCR = RCR_new*2-1;
  __DSB();

  DMA1_Channel5->CNDTR = SW_MSIZE*2;
  DMA1_Channel5->CMAR  = (uint32_t)Hf_wave[Bank_dma];

  // ,  
  DMA1_Channel5->CCR   = DMA_CCR_MINC    | //memory incremental mode
                         DMA_CCR_CIRC    | //circular mode
                         DMA_CCR_MSIZE_0 | //16 bit
                         DMA_CCR_PSIZE_0 | //16 bit
                         DMA_CCR_PL      | //vh priority
                         DMA_CCR_DIR     | //read from memory
                         DMA_CCR_EN;

 }

//-----------------------------------

 void HardFault_Handler()
 {

  while(1)
  {
   __no_operation();

  }
 }

 void NMI_Handler()
 {
  //  ram parity checking fail,   
  while(1)__no_operation();
 }

 void Default_Handler()
 {

  while(1)__no_operation();
 }
}



//   Reset_Handler                  ; Reset Handler
//
//   NMI_Handler                    ; NMI Handler
//   HardFault_Handler              ; Hard Fault Handler
//   PendSV_Handler                 ; PendSV Handler
//   SysTick_Handler                ; SysTick Handler
//
//  ; External Interrupts
//   WWDG_IRQHandler                ; Window Watchdog
//   PVD_IRQHandler                 ; PVD through EXTI Line detect
//   RTC_IRQHandler                 ; RTC through EXTI Line
//   FLASH_IRQHandler               ; FLASH
//   RCC_IRQHandler                 ; RCC
//   EXTI0_1_IRQHandler             ; EXTI Line 0 and 1
//   EXTI2_3_IRQHandler             ; EXTI Line 2 and 3
//   EXTI4_MDEV_IRQHandler            ; EXTI Line 4 to MDEV
//   TS_IRQHandler                  ; TS
//   DMA1_Channel1_IRQHandler       ; DMA1 Channel 1
//   DMA1_Channel2_3_IRQHandler     ; DMA1 Channel 2 and Channel 3
//   DMA1_Channel4_5_IRQHandler     ; DMA1 Channel 4 and Channel 5
//   ADC1_COMP_IRQHandler           ; ADC1, COMP1 and COMP2
//   TIM1_BRK_UP_TRG_COM_IRQHandler ; TIM1 Break, Update, Trigger and Commutation
//   TIM1_CC_IRQHandler             ; TIM1 Capture Compare
//   TIM2_IRQHandler                ; TIM2
//   TIM3_IRQHandler                ; TIM3
//   TIM6_DAC_IRQHandler            ; TIM6 and DAC
//   0                              ; Reserved
//   TIM14_IRQHandler               ; TIM14
//   TIMMDEV_IRQHandler               ; TIMMDEV
//   TIM16_IRQHandler               ; TIM16
//   TIM17_IRQHandler               ; TIM17
//   I2C1_IRQHandler                ; I2C1
//   I2C2_IRQHandler                ; I2C2
//   SPI1_IRQHandler                ; SPI1
//   SPI2_IRQHandler                ; SPI2
//   USART1_IRQHandler              ; USART1
//   USART2_IRQHandler              ; USART2
//   0                              ; Reserved
//   CEC_IRQHandler                 ; CEC
//   0                              ; Reserved

