 void cfg_sysfreq(void)
 {
  FLASH->ACR = 1<<4 | 1; //prefetch on, latency 1 wait state

  RCC->CFGR  = (u32)bin(0110)<<18;   //PLLMUL_x8

  RCC->CR   |= RCC_CR_PLLON;
  while ((RCC->CR & RCC_CR_PLLON) == 0) continue;

  RCC->CFGR |= bin(10); //PLL as system clock
  while (RCC->CFGR & bin(10)<<2 != bin(10)<<2) continue;
 }

 void cfg_rcc(void)
 {
  RCC->AHBENR  |= RCC_AHBENR_GPIOAEN | RCC_AHBENR_GPIOFEN;
  RCC->AHBENR  |= RCC_AHBENR_DMA1EN;

  RCC->APB2ENR |= RCC_APB2ENR_TIM1EN|RCC_APB2ENR_TIM17EN;
 }

 void cfg_gpio(void)
 {
  GPIO_InitTypeDef GIS;

  GIS.GPIO_Speed = GPIO_Speed_2MHz;

 //PF1,PF0 - reset pullup
  GIS.GPIO_Pin   = GPIO_Pin_0|GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOF, &GIS);

 //PA0, PA1, PA2 - NA
  GIS.GPIO_Pin   = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);

 //PA3, PA4 - TS PADS
  GIS.GPIO_Pin   = GPIO_Pin_4|GPIO_Pin_3;
  GIS.GPIO_Mode  = GPIO_Mode_OUT;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

 //PA5 - NA
  GIS.GPIO_Pin   = GPIO_Pin_5;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);

  //PA6 - AF tim1 (BKIN)
  GIS.GPIO_Pin   = GPIO_Pin_6;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_DOWN;

  GPIO_Init(GPIOA, &GIS);

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource6, GPIO_AF_2);

  //PA7 - AF tim17
  GIS.GPIO_Pin   = GPIO_Pin_7;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_5);

  //PB1 - NA
  GIS.GPIO_Pin   = GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOB, &GIS);

  //PA9,PA10 - timer_1 output
  GIS.GPIO_Pin   = GPIO_Pin_9|GPIO_Pin_10;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);
  GPIOA->BSRR = 1<<9|1<<10;

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9,  GPIO_AF_2);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_2);
 }

 void cfg_systic(void)
 {
  int frq = 1000;
  SysTick->LOAD  = SYSTEM_FRQ/frq-1;
  SysTick->VAL   = 0;
  SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk|SysTick_CTRL_TICKINT_Msk|SysTick_CTRL_ENABLE_Msk;
 }

 void cfg_t1(void)
 {
  TIM1->ARR   = 0xff;
  TIM1->RCR   = 3;

  TIM1->CR2   = 0; //OIS = 0

  TIM1->CCMR1 = (u32)pwm2<<8 |TIM_CCMR1_OC2PE;  //cnl2
  TIM1->CCMR2 = (u32)pwm1    |TIM_CCMR2_OC3PE;  //cnl3
  TIM1->CCER  = TIM_CCER_CC2E|TIM_CCER_CC3E;

  TIM1->DIER  = TIM_DIER_UDE;

  TIM1->DCR   = 1<<8 |                                           //2 transferts burst
                ((u32)&TIM1->CCR2 - (u32)&TIM1->CR1)/sizeof(u32);//offset from CR1

  TIM1->BDTR  = TIM_BDTR_OSSI|3<<8;  //lock level 3

  TIM1->SR    = 0;
  TIM1->EGR   = TIM_EGR_UG;
  TIM1->CR1   = TIM_CR1_CMS_0 | TIM_CR1_CEN;
 }

 void cfg_dma_t1(void)
 {
  DMA1_Channel5->CPAR  = (uint32_t)&TIM1->DMAR;
  DMA1_Channel5->CNDTR = 1;
  DMA1_Channel5->CCR   = DMA_CCR_MINC    | //memory incremental mode
                         DMA_CCR_CIRC    | //circular mode
                         DMA_CCR_MSIZE_0 | //16 bit
                         DMA_CCR_PSIZE_0 | //16 bit
                         DMA_CCR_PL      | //vh priority
                         DMA_CCR_DIR     | //read from memory
                         DMA_CCR_EN;
 }










